QGIS Application - Bug report #20872
QGIS 3.5 not loading or saving multi-dimensional arrays properly from PostGIS layers
2018-12-23 01:41 AM - Cory Albrecht

Status: Reopened

Priority: High

Assignee: Julien Cabieces

Category: Editing

Affected QGIS version:3.7(master) Regression?: Yes
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 28691
Description

| have map layers stored in PostgreSQL where a field contains two dimensional arrays of values.

Alternate History=# select name,full_name,alternate_name from "Balance of Power"."timeline-countries" where full_name is not
null and alternate_name is not null;

mN<

name | full_name | alternate_name
New Spain | {{en,"Viceroyalty of New Spain"}} | {{es,"Virreinato de la Nueva
Espana"},{es,"Nueva Espafna"}}
Mexico | {{es,"Imperio Mexicano"},{en,"Mexican Empire"}} | {{es,"Imperio Mexicano"}}
Mexico | {{es,"Estados Unidos Mexicanos"},{en,"United Mexican States"}} | {es,"Estados Unidos Mexicanos"}}
Mexico | {{es,"Estados Unidos Mexicanos"},{en,"United Mexican States"}} | {es,"Estados Unidos Mexicanos"}}
Alta California | {{es,"Republica de Alta California"},{en,"Republic of Alta California"}} | {{en,"Upper California"}}
New Spain | {{en,"Viceroyalty of New Spain"}} | {{es,"Virreinato de la Nueva

Espana"},{es,"Nueva Espana"}}

In QGIS 2.18.x those arrays appeared in Feature Attributes dialog in the PostgreSQL text format for specifying arrays, using curly braces
as seen in the psql output fragment above, and you could add to the arrays by entering new items in that format.

But in 3.5 that is no longer the case. Instead, only a bit of the text is shown in the text widget of the dialog.

https://i.ibb.co/FxC1jkf/image.png

Further, when you try to update that field with as value like

{{en,"Cape Colony"}}

it gets saved in the database as

{"{{en,\"Cape Colony\"}}"}

Associated revisions

Revision 0753b144 - 2019-02-22 09:12 AM - Julien Cabieces
fixes #20872 : Manage postgres multidimensionnal array

Revision 1957¢f53 - 2019-03-11 09:56 PM - Julien Cabieces

fixes #20872 : Manage postgres multidimensionnal array

Revision 2dbaa18f - 2019-03-11 09:58 PM - Julien Cabieces

fixes #20872 : Manage postgres multidimensionnal array

History

#1 - 2018-12-23 01:49 AM - Cory Albrecht

On loading the layer, the Qt messages windows displays lines like the following;

2018-12-22T19:48:10 WARNING Cannot find separator: },{es,"Nueva Espafa"}

2018-12-22T19:48:10 WARNING Error parsing array: {es,"Virreinato de la Nueva Espafna"},{es,"Nueva Espafia"}

2018-12-22T719:48:10 WARNING Cannot find separator: }

2018-12-22T19:48:10 WARNING Error parsing array: {en,"Viceroyalty of New Spain"}

#2 - 2018-12-23 07:17 PM - Cory Albrecht

| just tried 3.4.2 and the issue is there, too.

#3 - 2018-12-23 08:19 PM - Cory Albrecht

Here is what the feature attributes dialog looks like in 2,18.25 for the same feature object.

https://i.ibb.co/ddnWm4c/Screenshot-from-2018-12-23-14-14-27.png

#4 - 2019-01-17 04:02 AM - Cory Albrecht

Ping.

#5 - 2019-01-17 11:26 AM - Giovanni Manghi

- Priority changed from Normal to High

- Regression? changed from No to Yes

#6 - 2019-01-30 02:25 PM - Julien Cabieces
- Assignee set to Julien Cabieces

#7 - 2019-01-31 03:56 PM - Julien Cabieces
- Pull Request or Patch supplied changed from No to Yes

Proposed PR : https://github.com/qgis/QGIS/pull/9048
https://github.com/qgis/QGIS/pull/9048

#8 - 2019-03-03 06:49 PM - Cory Albrecht

Still happening in 3.45, 3.60 and 3.7

#9 - 2019-03-03 06:49 PM - Giovanni Manghi
- Affected QGIS version changed from 3.5(master) to 3.7(master)

#10 - 2019-03-04 02:02 PM - Julien Cabieces

Still happening in 3.45, 3.60 and 3.7

Proposed PR isn't accepted yep.

#11 - 2019-03-05 09:35 AM - Julien Cabieces
- Status changed from Open to Closed
- % Done changed from 0 to 100

Applied in changeset commit:qgis|0753b144b92763b18021f1d706a1cf184323b1aa.

#12 - 2019-03-19 12:15 AM - Cory Albrecht

Julien Cabieces wrote:

Applied in changeset commit:qgis|0753b144b92763b18021f1d706a1cf184323b1aa.

When will this be in a nightly? | just tried 3.7 and it's not there yet.

#13 - 2019-03-20 08:46 AM - Julien Cabieces
- File scr_table.png added

- File scr_rgst.png added

- File scr_form.png added

Here is some screenshots with current master
i my _table :: Total des entités: 3, filtrées: 3,

y 4] > LT E S D B = &8 &
id arrays
1 1| {{en,"tutu tito"},{fr,"hello bobbo"}}
2 2 {en,"tutu henru}, {fr,"hello coucou titi foo"}, {tata,"testl test2 test3"}
3 3 {en}, {fr}, {titi}
id 2 | v
(4| Valeur

{en."tutu henru"}
{fr."hello coucou titi foo"}

arrays {tata,"test] test2 test3"}

Does it look like what you're seeing on your version of QGIS?

Could you please check the QGIS version once launched in the help > About dialog.

#14 - 2019-03-21 04:12 PM - Cory Albrecht
Julien Cabieces wrote:

Does it look like what you're seeing on your version of QGIS?

| did not use the new list widget, just the plain old text widget, as shown in my screencaps.
Any text representation that the psgl command-line client uses to either show the results of a query, or how one might type in the command by hand as a
raw SQL, one should be able to simply copy-paste back and forth between a terminal and QGIS in either the Feature Attribute form's plain text widget or in

the Attribute Table columns.

That way all possible PostGIS data types have some kind of minimal support, and special widgets can wait until somebody has the inclination and time to

write them.

Could you please check the QGIS version once launched in the help > About dialog.

Whatever was in the PPA https://qgis.org/ubuntu-nightly Monday afternoon and evening, but | reverted to 3.6. | will check whatever is in the PPA once | get

home from work.

#15 - 2019-03-22 08:40 AM - Julien Cabieces

- Status changed from Closed to Reopened
https://qgis.org/ubuntu-nightly

| see, there is an additionnal issue when we use the plain text display (the list widget is working by the way).

| reopen the ticket, and I'll try to find a way to correct this.

#16 - 2019-03-22 10:34 AM - Julien Cabieces

Proposed PR : https://github.com/qgis/QGIS/pull/9610

Be aware that there is still a problem to deal with integer and float array in plain text.

Files

scr_rgst.png 15.5 KB 2019-03-20 Julien Cabieces
scr_form.png 10 KB 2019-03-20 Julien Cabieces
scr_table.png 229 KB 2019-03-20 Julien Cabieces
